From Fedora Project Wiki
m
Line 17: Line 17:
  
 
== Build Architecture and File Placement ==
 
== Build Architecture and File Placement ==
The following only affects the files that the package installs into <code>%{_libdir}/ruby/vendor_ruby</code> (architecture specific) and <code>%{_datadir}/ruby/vendor_ruby</code> (architecture independent), i.e., Ruby library files. All other files in a Ruby package must adhere to the general Fedora Extras packaging conventions.
+
The following only affects the files that the package installs into <code>%{_libdir}/ruby/vendor_ruby</code> (architecture specific) and <code>%{_datadir}/ruby/vendor_ruby</code> (architecture independent), i.e. Ruby library files. All other files in a Ruby package must adhere to the general Fedora Extras packaging conventions.
  
 
All non-gem ruby packages '''must''' require ruby-devel package at build time with a <code>BuildRequires: ruby-devel</code>.
 
All non-gem ruby packages '''must''' require ruby-devel package at build time with a <code>BuildRequires: ruby-devel</code>.
  
A list of the macros from ruby-devel package follows:
+
A list of the macros from ruby-devel (file /etc/rpm/macros.ruby) package follows:
  
 
{| border="1" cellpadding="20" cellspacing="0"
 
{| border="1" cellpadding="20" cellspacing="0"
Line 37: Line 37:
 
|-
 
|-
 
|<code>%{ruby_sitearchdir}</code>
 
|<code>%{ruby_sitearchdir}</code>
|/usr/local/lib64/ruby/vendor_ruby
+
|/usr/local/lib64/ruby/site_ruby
 
|Place for local architecture specific (e.g. *.so) files.
 
|Place for local architecture specific (e.g. *.so) files.
 
|-
 
|-
 
|<code>%{ruby_sitelibdir}</code>
 
|<code>%{ruby_sitelibdir}</code>
|/usr/local/share/ruby/vendor_ruby
+
|/usr/local/share/ruby/site_ruby
 
|Place for local architecture independent (e.g. *.rb) files.
 
|Place for local architecture independent (e.g. *.rb) files.
 
|}
 
|}
  
  
{{admon/warning|Site versus Vendor|Do not use <code>%{ruby_sitelibdir}</code> and <code>%{ruby_sitearchdir}</code> for packaging, as they are only local. Use <code>%{ruby_vendorlibdir}</code> and <code>%{ruby_vendorarchdir}</code>.}}
+
{{admon/warning|Site versus Vendor|Previously, %{ruby_sitelibdir} and %{ruby_sitearchdir} were used. However, as they are meant only for local installations, please use <code>%{ruby_vendorlibdir}</code> and <code>%{ruby_vendorarchdir}</code> instead.}}
  
 
=== Pure Ruby packages ===
 
=== Pure Ruby packages ===

Revision as of 08:33, 21 December 2011

Ruby Packaging Guidelines

Each Ruby package must indicate the Ruby ABI version it depends on with a line like

Requires: ruby(abi) = 1.9.1

Ruby packages must require ruby at build time with a BuildRequires: ruby, and may indicate the minimal ruby version they need for building.

Naming Guidelines

Note.png These naming guidelines only apply to ruby packages whose main purpose is providing a Ruby library; packages that mainly provide user-level tools that happen to be written in Ruby do not need to follow these naming guidelines, and should follow the general NamingGuidelines instead.

The name of a ruby extension/library package must be of the form ruby-UPSTREAM. If the upstream name UPSTREAM contains ruby, that should be dropped from the name. For example, the SQLite database driver for ruby is called sqlite3-ruby. The corresponding Fedora package should be called ruby-sqlite3, and not ruby-sqlite3-ruby.

A ruby extension/library package must indicate what it provides with a Provides: ruby(LIBRARY) = VERSION declaration in the spec file. The string LIBRARY should be the same as what is used in the require statement in a Ruby script that uses the library. The VERSION should be the upstream version of the library, as long as upstream follows a sane versioning scheme. For example, a Ruby script using the SQLite database driver will include it with require 'sqlite3'. The specfile for the corresponding Fedora package must contain a line Provides: ruby(sqlite3) = 1.1.0, assuming the package contains version 1.1.0 of the library.

Build Architecture and File Placement

The following only affects the files that the package installs into %{_libdir}/ruby/vendor_ruby (architecture specific) and %{_datadir}/ruby/vendor_ruby (architecture independent), i.e. Ruby library files. All other files in a Ruby package must adhere to the general Fedora Extras packaging conventions.

All non-gem ruby packages must require ruby-devel package at build time with a BuildRequires: ruby-devel.

A list of the macros from ruby-devel (file /etc/rpm/macros.ruby) package follows:

Macro Expanded path Usage
%{ruby_vendorarchdir} /usr/lib{64}/ruby/vendor_ruby Place for architecture specific (e.g. *.so) files.
%{ruby_vendorlibdir} /usr/share/ruby/vendor_ruby Place for architecture independent (e.g. *.rb) files.
%{ruby_sitearchdir} /usr/local/lib64/ruby/site_ruby Place for local architecture specific (e.g. *.so) files.
%{ruby_sitelibdir} /usr/local/share/ruby/site_ruby Place for local architecture independent (e.g. *.rb) files.


Warning.png
Site versus Vendor
Previously, %{ruby_sitelibdir} and %{ruby_sitearchdir} were used. However, as they are meant only for local installations, please use %{ruby_vendorlibdir} and %{ruby_vendorarchdir} instead.

Pure Ruby packages

Pure Ruby packages must be built as noarch packages.

The Ruby library files in a pure Ruby package must be placed into %{ruby_vendorlibdir} (or its proper subdirectory). The specfile must use this macro.

Ruby packages with binary content/shared libraries

For packages with binary content, e.g., database drivers or any other Ruby bindings to C libraries, the package must be architecture specific.

The binary files in a Ruby package with binary content must be placed into %{ruby_vendorarchdir} (or its proper subdirectory). The Ruby files in such a package should be placed into %{ruby_vendorlibdir}. The specfile must use these paths.

For packages which create C shared libraries using extconf.rb

export CONFIGURE_ARGS="--with-cflags='%{optflags}'"

should be used to pass CFLAGS to Makefile correctly. Also, to place the files to the correct folders during build, pass --vendor to extconf.rb like this:

extconf.rb --vendor

The CONFIGURE_ARGS definition applies to Ruby Gems, too.

Ruby Gems

Ruby Gems are Ruby's own packaging format. Gems contain a lot of the same metadata that RPM's need, making fairly smooth interoperation between RPM and Gems possible. This guideline ensures that Gems are packaged as RPM's in a way that ensures (1) that such RPM's fit cleanly with the rest of the distribution and (2) make it possible for the end user to satisfy dependencies of a Gem by installing the appropriate RPM-packaged Gem.

Both RPM's and Gems use similar terminology --- there are specfiles, package names, dependencies etc. for both. To keep confusion to a minimum, whenever the term from the Gem world is meant, it is explicitly called the 'Gem specification'. An unqualified 'package' in the following always means an RPM.

  • Spec files must contain definition of %{gem_name}, which is the name from the Gem's specification.
  • Packages that contain Ruby Gems must be called rubygem-%{gem_name}.
  • The Source of the package must be the full URL to the released Gem archive; the version of the package must be the Gem's version.
  • The package must have a Requires on ruby(rubygems) and a BuildRequires on rubygems-devel. The rubygems-devel package contains a file named macros.rubygems with these macro definitions:
Macro Expanded path Usage
%{gem_dir} /usr/share/gems Top directory for the Gem structure.
%{gem_instdir} %{gem_dir}/gems/%{gem_name}-%{version} Directory with the actual content of the Gem.
%{gem_libdir} %{gem_instdir}/lib The lib folder of the Gem.
%{gem_cache} %{gem_dir}/cache/%{gem_name}-%{version}.gem The cached Gem.
%{gem_spec} %{gem_dir}/specifications/%{gem_name}-%{version}.gemspec The gemspec file of the Gem.
%{gem_docdir} %{gem_dir}/doc/%{gem_name}-%{version} The rdoc documentation of the Gem.
%{gem_extdir} %{_libdir}/gems/exts/%{gem_name}-%{version} The directory for binary Gem extensions.
  • The package must provide rubygem(%{gem_name}) where gem_name is the name from the Gem's specification. For every dependency on a Gem named gemdep, the package must contain a Requires on rubygem(%{gemdep}) with the same version constraints as the Gem
  • The %prep section should contain the local gem install similar to this (assuming that the %{gem_name}-%{version}.gem is SOURCE0):
%setup -q -c -T
mkdir -p .%{gem_dir}
gem install \
	-V \
	--local \
        --install-dir .%{gem_dir} \
	--force \
	--rdoc \
	%{SOURCE0}
  • The %build section of the specfile should be empty.
  • The %install section should then be used to copy the files to appropriate directory structure under %{buildroot}.
    • The Gem must be installed into %{gem_dir}.
  • The package must own the following files and directories:
%dir %{gem_instdir}
%{gem_libdir}
%{gem_cache}
%{gem_spec}
%doc %{gem_docdir}
  • If the Gem only contains pure Ruby code, it must be marked as BuildArch: noarch. If the Gem contains binary content (e.g., for a database driver), it must be marked as architecture specific.

Ruby Gem with extension libraries written in C

When a Ruby Gem contains extension libraries written in C,

  • First, %prep stage must contain %setup -q -c -T to create the directory where C libraries are compiled.
  • Then at %build stage the Ruby Gem must be installed under the directory created at %prep stage to get C libraries compiled under there.
  • During the %install section all architecture specific content must be moved from the %{gem_instdir} to the %{gem_extdir}.
    • The package then must own %{gem_extdir} directory.
  • When gem install is used to install Gem file, using -V option is recommended to check if CFLAGS is correctly honored.
  • Installed C codes (usually under %{gem_instdir}/ext) may be removed even if gem contents %{gem_name} reports that installed C codes should be found there.

Packaging for Gem and non-Gem use

Note.png
Legacy
Packaging for non-Gem use is no longer needed, as Ruby requires Rubygems by default.

If the same Ruby library is to be packaged for use as a Gem and as a straight Ruby library without Gem support, it must be packaged as a Gem first. To make it available to code that does not use Ruby Gems, a subpackage called ruby-%{gem_name} must be created in the rubygem-%{gem_name} package such that

  • The subpackage must require rubygem(%gem_name) = %version
  • The subpackage must provide ruby(LIBRARY) = %{version} where LIBRARY is the same as in the general Ruby guideline above.
  • All the toplevel library files of the Gem must be symlinked into %{ruby_vendorlibdir}.
  • The subpackage must own these symbolic links.

As an example, for activesupport, the rubygem-activesupport package would have a subpackge ruby-activesupport:

%package -n ruby-activesupport
...
Requires: rubygem(activesupport) = %version
Provides: ruby(active_support) = %version  # The underscore is intentional, not a typo
...
%files -n ruby-activesupport
%{ruby_vendorlibdir}/active_support
%{ruby_vendorlibdir}/active_support.rb

Running tests

If there are tests available for the package (even separately, for example not included in the Gem, but available in the upstream repository), you must run them. The tests should not be run using Rake - Rake almost always draws in some unnecessary dependencies like hoe or gemcutter.

To run the tests using MiniTest (which is included in Ruby), you can usually use something like

testrb -Ilib test

To run the tests using Test::Unit (you must use BuildRequires: rubygem(test-unit)), you can usually use something like

testrb2 -Ilib test

To run the tests using RSpec >= 2 (you must use BuildRequires: rubygem(rspec-core)), you can usually use something like

rspec -Ilib test


Tips for Packagers

Gems carry a lot of metadata; gem2rpm is a tool to generate an initial specfile and/or source RPM from a Gem. The generated specfile still needs some hand-editing, but conforms to 90% with this guideline.